SystemOrganization addCategory: #'Xpf-Support-Quickstart'!

Object subclass: #XpfQuickstart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Quickstart'!

!XpfQuickstart class methodsFor: 'user interface' stamp: 'mt 3/17/2009 10:06'!
createButton: actionSel label: labelSel
	
	| btn |
	btn := UITheme current
		newButtonIn: self
		for: self
		getState: #state
		action: actionSel
		arguments: nil
		getEnabled: nil
		label: labelSel help: ''. 
	btn 
		vResizing: #spaceFill; 
		hResizing: #spaceFill.
	^ btn! !

!XpfQuickstart class methodsFor: 'user interface' stamp: 'mt 3/11/2009 14:45'!
createUpdateButton
	
	| btn |
	btn := PluggableButtonMorph on: XpfUpdateModel new getState: #state action: #update label: #info.
	btn 
		vResizing: #spaceFill; 
		hResizing: #spaceFill.
	^ btn! !

!XpfQuickstart class methodsFor: 'instance creation' stamp: 'mt 3/17/2009 10:08'!
open
	
	| align uBtn|
	align := AlignmentMorph newBounds: (50@50 corner: 600@80).
	uBtn := self createUpdateButton.
	align addMorph: uBtn.
	align addMorph: uBtn model.
	align addMorph: (self createButton: #stopHttpService label: 'Stop Server').
	align addMorph: (self createButton: #startHttpService label: 'Start Server').
	align addMorph: (self createButton: #openClientForServer label: 'Client').
	align addMorph: (self createButton: #startAdminTool label: 'AdminTool').
	align openInWorld.! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'mt 3/10/2009 17:02'!
openClientForServer
	XpfClient open.! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'mt 3/4/2009 09:51'!
startAdminTool
	XpfAdminTool open! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'mt 3/10/2009 17:00'!
startHttpService
	XpfService start.! !

!XpfQuickstart class methodsFor: 'model' stamp: 'mt 3/11/2009 14:58'!
state

	^ true! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'mt 3/10/2009 17:01'!
stopHttpService
	XpfService stop.! !

Morph subclass: #XpfUpdateModel
	instanceVariableNames: 'nextUpdate info state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Quickstart'!

!XpfUpdateModel class methodsFor: 'as yet unclassified' stamp: 'mt 3/11/2009 16:01'!
packages

	^ {
    'Xpf-CodeMarker'.
    'Rest-Server'. 
    'Rest-Client'.
    'Rest-Tests'.
    'Xpf-Server'.
    'Xpf-Client'} collect: [:n | MCPackage named: n].! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/17/2009 10:04'!
check

	self hasUpdates
		ifTrue: [self state: true; info: 'Update now!!'; color: Color green]
		ifFalse: [self state: false; info: 'No updates available.'; color: Color gray].! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/11/2009 17:20'!
databaseResetNeededFor: someVersions

	someVersions do: [:version | (version package name startsWith: 'Xpf-Server') ifTrue: [
			^ UITheme current questionWithoutCancelIn: World text: 'Do you want to reset the database?' title: 'Database structure changed']].
	^ false! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/11/2009 16:26'!
hasUpdates

	self class packages do: [:pkg |
		pkg workingCopy possiblyNewerVersions size > 0
			ifTrue: [^ true]].
		
	^ false! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/11/2009 16:50'!
info

	^ info! !

!XpfUpdateModel methodsFor: 'accessing' stamp: 'mt 3/11/2009 16:51'!
info: anObject

	info := anObject.
	self changed: #info.! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/17/2009 10:02'!
initialize

	super initialize.
	self
		info: '...';
		height: 25;
		width: 25;
		state: false;
		check.
		
	[[true] whileTrue: [
		(Delay forDuration: (Duration minutes: 5)) wait.
		self check]] fork.! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/11/2009 17:02'!
newVersions

	| result newerVersionNames newestVersionName maxVer fileName repo |
	result := OrderedCollection new.
	self class packages do: [:pkg |
		newerVersionNames := pkg workingCopy possiblyNewerVersions.
		newerVersionNames ifNotEmpty: [
			maxVer := (newerVersionNames collect: [:name | (name findTokens: {$.}) last asNumber]) max.
			newestVersionName := (newerVersionNames detect: [:v | v endsWith: maxVer asString]).
			repo := pkg workingCopy repositoryGroup repositories detect: [:r | r includesVersionNamed: newestVersionName].
			fileName := newestVersionName, '.mcz'.
			result add: (repo loadVersionFromFileNamed: fileName)]].
	^ result! !

!XpfUpdateModel methodsFor: 'accessing' stamp: 'mt 3/11/2009 16:50'!
nextUpdate
	^ nextUpdate! !

!XpfUpdateModel methodsFor: 'accessing' stamp: 'mt 3/11/2009 16:50'!
nextUpdate: anObject
	^ nextUpdate := anObject! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/11/2009 16:50'!
state

	^ state! !

!XpfUpdateModel methodsFor: 'accessing' stamp: 'mt 3/11/2009 16:51'!
state: anObject

	state := anObject.
	self changed: #state.! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/11/2009 17:21'!
update

	| nv nvString |
	self state ifFalse: [^ self check].
	nv := self newVersions.
	
	nvString := (nv collect: [:v | v package name])
		inject: ''
		into: [:old :each | old, String cr, each ].
	
	(UITheme current
		questionWithoutCancelIn: World
		text: 'Do you want to update the following packages?', String cr, nvString
		title: 'Updates available') ifTrue: [
		nv do: [:version | version merge].
		self check].
	
	(self databaseResetNeededFor: nv) ifTrue: [
		XpfUser initialize.
		XpfProject initialize].
	! !
